# import numpy as np
# import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt

__author__ = 'Riccardo Guidotti'


def main():
    print 'Hello World!'

    # load data
    # ----------------------
    input_filename = '/Users/riccardo/Documents/Didattica/CorsoDM_2015_2016/python-workspace/adult.csv'
    df = pd.read_csv(input_filename, skipinitialspace=True)

    # data visualization
    # ----------------------
    df.info()
    print df.head()
    print df.tail()
    print df.index
    print df.columns
    print df.values

    # data selection
    # -----------------------
    print df['age'].head()
    print df[0:3]
    print df.loc[0]
    print df.loc[:, ['age', 'workclass']].head()
    print df.loc[0:3, ['age', 'workclass']]
    print df.at[0, 'workclass']

    # iloc for numeric selection

    print df[df.age > 50].head()

    # missing values
    # ----------------
    # pandas primarily uses the value np.nan to represent missing data.
    # It is by default not included in computations.
    # See the Missing Data section Reindexing allows you to change/add/delete the index on a specified axis.
    # This returns a copy of the data.

    df1 = df.reindex(index=range(0, 4), columns=list(df.columns) + ['mv'])
    df1.loc[0:1, 'mv'] = 1
    print df1

    # drop rows with missing values
    print df1.dropna(how='any')

    # fill missing values
    print df1.fillna(value=5)


    # statistical operations
    # ----------------------------
    print df.describe()
    print df.mean()
    print df.age.corr(df['capital-gain'])
    print df.corr()
    print df['marital-status'].unique()
    print df['marital-status'].value_counts()

    # show graph
    # ----------------------------
    df['marital-status'].value_counts().plot(kind='bar', color='r', alpha=0.7)
    plt.show()

    df['occupation'].value_counts().plot(kind='barh', color='b', alpha=0.7)
    plt.show()

    df['age'].hist()
    plt.show()

    plt.scatter(df['age'], df['hours-per-week'], color='g')
    plt.show()

    pd.scatter_matrix(df, diagonal='kde')
    plt.show()


if __name__ == "__main__":
    main()
